#!/bin/sh
. config.conf
[[ ! -r $serv_func ]] && {
  echo "Service script not found..."
  exit 1
}
source $serv_func

if [[ "x${underscore_w64}" = "x1" ]]; then
  bu_underscore="--enable-leading-mingw64-underscores"
  w64_underscore="--enable-leading-underscores"
else
  bu_underscore="--disable-leading-mingw64-underscores"
  w64_underscore="--disable-leading-underscores"
fi

function before_start {
  # unmount /mingw
  local ss="$(tc_conf_get ka_mingw_target)"
  [[ -d $ss ]] && fsUnLink "$ss"
  # prepare /mingw_new
  local s1="$(tc_conf_get ka_mingw_new_source)"
  [[ ! -d $s1 ]] && mkdir -p "$s1"
  local s2="$(tc_conf_get ka_mingw_new_target)"
  [[ -d $s2 ]] && fsUnLink "$s2"
  fsLink "$s2" "$s1"
  # select default compiler
  tc_select
}

function before_w64 {
  # unmount /mingw
  local ss="$(tc_conf_get ka_mingw_target)"
  [[ -d $ss ]] && fsUnLink "$ss"
  # prepare /mingw_new
  local s1="$(tc_conf_get ka_mingw_new_source)"
  [[ ! -d $s1 ]] && mkdir -p "$s1"
  local s2="$(tc_conf_get ka_mingw_new_target)"
  [[ -d $s2 ]] && fsUnLink "$s2"
  fsLink "$s2" "$s1"
  # select new toolchain
  fsLink "$ss" "$s2"
}

function get_prefix {
  printf "%s\n" "$(tc_conf_get ka_mingw_new_target)"
}

function extract_h_version {
  local _str=${1:-"VERSION"}
  local _file=${2:-"test.h"}
  local _ret=`grep "$_str" $_file | sed -e "s/\t/ /" | tr -s ' ' | cut -d ' ' -f 3`
  printf "%s" "$_ret"
}

function get_cc {
  local _bit=${1:-32}
  local _ret="_CC_${_bit}"
  _ret=${!_ret}
  printf "%s" "$_ret"
}

function get_cxx {
  local _bit=${1:-32}
  local _ret="_CXX_${_bit}"
  _ret=${!_ret}
  printf "%s" "$_ret"
}
