#!/bin/sh
if [[ -r serv.sh ]]; then source serv.sh; elif [[ -r ../serv.sh ]]; then source ../serv.sh; fi
##-Global-defines-###########################################
bu_ver=".last"
#bu_ver="-2.21.51"
bName="binutils${bu_ver}"
bSrc=$src_src/$bName
bdir="binutils"
b_in=$bdir/wrk
b_src=$bdir/src
##-Set-local-variables-######################################
#_prx="$(get_prefix)"
_prx="$(get_prefix)"
_hst32_="i686-w64-mingw32"
_hst64_="x86_64-w64-mingw32"
_cf="$(GetCFLAGS 32)"
_lf="$(GetLDFLAGS 32)"
#_tag_dir="${_prx}/$(GetHOST 32)"
_tag_dir="${_prx}/${_hst32_}"
_tag_file=${bdir}.tag
##-Define-build-API-:)#######################################

##-Prepare-to-build-#########################################
function __int_prepare() {
  cd $src_bld
  [[ ! -d $src_bld/$b_in ]] && mkdir -p $src_bld/$b_in
  [[   -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[   -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
  mkdir -p $src_bld/$b_in
  fsLink $src_bld/$b_src $bSrc
}
##-Configure-################################################
function __int_config() {
  cd $src_bld/$b_in

#  CC="$(get_cc 32)" \
  CFLAGS="${_cf}" \
  CPPFLAGS="${_cf}" \
  CXXFLAGS="${_cf}" \
  LDFLAGS="${_lf}" \
  ../src/configure \
    --prefix=${_prx} \
    --with-sysroot=${_prx} \
    --with-build-sysroot=${_prx} \
    --build="${_hst32_}" \
    --target="${_hst32_}" \
    --enable-targets="${_hst32_}" \
    \
    --with-gmp=${_prx}/sup \
    --with-mpfr=${_prx}/sup \
    --with-mpc=${_prx}/sup \
    --with-libelf=${_prx}/sup \
    --with-ppl=${_prx}/sup \
    --with-cloog=${_prx}/sup \
    \
    --enable-static \
    --disable-shared \
    --disable-nls \
    --disable-multilib \
    --with-system-zlib \
    \
    --disable-rpath \
    --disable-install-libiberty \
    --disable-install-libbfd \
    \
    --enable-64-bit-bfd \
    --enable-largefile \
    --enable-initfini-array \
    --enable-lto \
    --disable-werror
}
##-Make-#####################################################
function __int_make() {
  cd $src_bld/$b_in
  make -j5 all
}
##-Install-##################################################
function __int_install() {
  cd $src_bld/$b_in
#  make install
  make install-strip
  [[ -d ${_prx}/lib ]] && rm -rf ${_prx}/lib
  [[ -d ${_prx}/lib32 ]] && rm -rf ${_prx}/lib32
  [[ -d ${_prx}/share ]] && rm -rf ${_prx}/share
}
##-Post-Install-steps-#######################################
function __int_post_install() {
  cd $src_bld
  [[ ! -d ${_tag_dir} ]] && mkdir -p ${_tag_dir}
  local vv="`${_prx}/${_hst32_}/bin/ld.exe --version | grep Binutils | cut -d ' ' -f 5`"
  _fl=${_tag_dir}/${_tag_file}
  echo "GNU Binutils ${vv}" >${_fl}
  echo "VER: $(get_dir_ver $src_bld/$b_src)" >>${_fl}
}
##-Cleanup-##################################################
function __int_clean() {
  cd $src_bld
  [[ -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[ -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
}
##-Batch-build-##############################################
function __int_batch() {
  __int_prepare
  __int_config
  __int_make
  __int_install
  __int_post_install
  __int_clean
}
#############################################################
for i; do
  __int_${i}
done
