#!/bin/sh
if [[ -r serv.sh ]]; then source serv.sh; elif [[ -r ../serv.sh ]]; then source ../serv.sh; fi
##-Global-defines-###########################################
gcc_ver="4.6.2"
bName="gcc-${gcc_ver}"
bSrc=$src_src/$bName
bdir="gcc462"
b_in=$bdir/wrk
b_src=$bdir/src
##-Set-local-variables-######################################
_prx="$(get_prefix)"
_hst32_="i686-w64-mingw32"
_hst64_="x86_64-w64-mingw32"
_cf="$(GetCFLAGS 32)"
_lf="$(GetLDFLAGS 32)"
_tag_dir=${_prx}/${_hst32_}
_tag_file=${bdir}.tag
##-Define-build-API-:)#######################################

##-Prepare-to-build-#########################################
function __int_prepare() {
  cd $src_bld
}
##-Configure-################################################
function __int_config() {
  cd $src_bld/$b_in
}
##-Make-#####################################################
function __int_make() {
  cd $src_bld/$b_in
  make -j5 all
}
##-Install-##################################################
function __int_install() {
  cd $src_bld/$b_in
  make install
  [[ -d ${_prx}/include ]] && rm -rf ${_prx}/include
  [[ -d ${_prx}/info ]] && rm -rf ${_prx}/info
  [[ -r ${_prx}/lib/libiberty.a ]] && rm -f ${_prx}/lib/libiberty.a
  [[ -d ${_prx}/man ]] && rm -rf ${_prx}/man
  [[ -d ${_prx}/share ]] && rm -rf ${_prx}/share
#  [[ -d ${_prx}/lib32 ]] && rm -rf ${_prx}/lib32
}
##-Post-Install-steps-#######################################
function __int_post_install() {
  cd $src_bld
  [[ ! -d ${_tag_dir} ]] && mkdir -p ${_tag_dir}
  local _fl=${_tag_dir}/${_tag_file}
  local hh=${_hst32_}
  #mkheaders.conf
  local f1=$_prx/lib/gcc/$hh/${gcc_ver}/install-tools/mkheaders.conf
  [[ -r $f1 ]] && {
    echo "Patch: $f1..."
    mv -f $f1 $f1.old
    sed -e 's|/mingw_new|/mingw|' $f1.old >$f1
    rm -f $f1.old
  }
  #libgomp.la
  local f1=$_prx/lib/gcc/$hh/${gcc_ver}/libgomp.la
  [[ -r $f1 ]] && {
    echo "Patch: $f1..."
    mv -f $f1 $f1.old
    sed -e "s|dependency_libs='.*lpthread'|dependency_libs=' -L/mingw/$hh/lib -lpthread'|" $f1.old >$f1
    mv -f $f1 $f1.old
    sed -e 's|/mingw_new|/mingw|' $f1.old >$f1
    rm -f $f1.old
  }
  #libssp.la libssp_nonshared.la "libstdc++.la" "libsupc++.la" libquadmath.la
  for i in libssp.la libssp_nonshared.la libstdc++.la libsupc++.la libquadmath.la; do
    local f1=$_prx/lib/gcc/$hh/${gcc_ver}/$i
    echo "Patch: $f1..."
    [[ -r $f1 ]] && {
      mv -f $f1 $f1.old
      sed -e "s|dependency_libs='.*/lib'|dependency_libs=' -L/mingw/$hh/lib'|" $f1.old >$f1
      mv -f $f1 $f1.old
      sed -e 's|/mingw_new|/mingw|' $f1.old >$f1
      rm -f $f1.old
    }
  done
  # "libstdc++.a-gdb.py"
  [[ -r "$_prx/lib/gcc/$hh/${gcc_ver}/libstdc++.a-gdb.py" ]] && rm -f "$_prx/lib/gcc/$hh/${gcc_ver}/libstdc++.a-gdb.py"
  #mkheaders
  local f1=$_prx/libexec/gcc/$hh/${gcc_ver}/install-tools/mkheaders
  [[ -r $f1 ]] && {
    echo "Patch: $f1..."
    mv -f $f1 $f1.old
    sed -e 's|/mingw_new|/mingw|' $f1.old >$f1
    rm -f $f1.old
  }
  local f1=$_prx/libexec/gcc/$hh/${gcc_ver}/liblto_plugin.la
  [[ -r $f1 ]] && {
    echo "Patch: $f1..."
    mv -f $f1 $f1.old
    sed -e 's|/mingw_new|/mingw|' $f1.old >$f1
    rm -f $f1.old
  }
  local f1=$_prx/libexec/gcc/$hh/${gcc_ver}/liblto_plugin-0.dll
  $_prx/$hh/bin/strip -p -g --strip-unneeded $f1
  $_prx/bin/$hh-gcc --version 2>&1 | grep '(GCC)' >${_fl}
  echo "$(get_dir_ver $src_bld/$b_src)" >>${_fl}
#  svn info | grep "evision:" >>${_fl}
#  svn info | grep "Changed Date:" >>${_fl}
}
##-Cleanup-##################################################
function __int_clean() {
  cd $src_bld
  [[ -d $_prx/mingw ]] && fsUnLink $_prx/mingw
  [[ -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[ -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
}
##-Batch-build-##############################################
function __int_batch() {
  __int_prepare
  __int_config
  __int_make
  __int_install
  __int_post_install
  __int_clean
}
#############################################################
for i; do
  __int_${i}
done
