#!/bin/sh
if [[ -r serv.sh ]]; then source serv.sh; elif [[ -r ../serv.sh ]]; then source ../serv.sh; fi
##-Global-defines-###########################################
gcc_ver="4.6.2"
bName="gcc-${gcc_ver}"
bSrc=$src_src/$bName
bdir="gcc462"
b_in=$bdir/wrk
b_src=$bdir/src
##-Set-local-variables-######################################
_prx="$(get_prefix)"
_hst32_="i686-w64-mingw32"
_hst64_="x86_64-w64-mingw32"
_cf="$(GetCFLAGS 64)"
_lf="$(GetLDFLAGS 64)"
_tag_dir=${_prx}/${_hst64_}
_tag_file=${bdir}.tag
##-Define-build-API-:)#######################################

##-Prepare-to-build-#########################################
function __int_prepare() {
  cd $src_bld
  [[ ! -d $src_bld/$b_in ]] && mkdir -p $src_bld/$b_in
  [[   -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[   -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
  mkdir -p $src_bld/$b_in
  fsLink $src_bld/$b_src $bSrc

  [[ -r $src_bld/$b_src/gcc/version.c.original ]] && mv -f $src_bld/$b_src/gcc/version.c.original $src_bld/$b_src/gcc/version.c
  local brnd="(x86_64.generic.Komisar)"
  [[ -d $_prx/mingw ]] && fsUnLink $_prx/mingw
  [[ ! -d $_prx/mingw ]] && fsLink $_prx/mingw $_prx/${_hst32_}
}
##-Configure-################################################
function __int_config() {
  cd $src_bld/$b_in

  CFLAGS="${_cf}" \
  CFLAGS_FOR_TARGET="${_cf}" \
  LDFLAGS="${_lf}" \
  ../src/configure \
    --prefix=${_prx} \
    --with-sysroot=${_prx} \
    --with-build-sysroot=${_prx} \
    --build=${_hst32_} \
    --target=${_hst64_} \
    \
    --with-gmp=${_prx}/sup \
    --with-mpfr=${_prx}/sup \
    --with-mpc=${_prx}/sup \
    --with-libelf=${_prx}/sup \
    --with-ppl=${_prx}/sup \
    --with-cloog=${_prx}/sup \
    \
    --disable-ppl-version-check \
    --disable-cloog-version-check \
    \
    --with-host-libstdcxx='-lstdc++ -lsupc++' \
    --disable-shared \
    --enable-static \
    --disable-bootstrap \
    --disable-win32-registry \
    --enable-threads=win32 \
    --enable-languages=c,c++ \
    --enable-version-specific-runtime-libs \
    --disable-multilib \
    --disable-rpath \
    --with-system-zlib \
    --disable-werror \
    --disable-nls \
    --enable-decimal-float \
    --disable-debug \
    --enable-lto \
    --enable-64bit \
    --enable-largefile \
    --enable-sjlj-exceptions \
    --enable-fully-dynamic-string \
    --enable-libssp \
    --enable-libgomp
}
##-Make-#####################################################
function __int_make() {
  cd $src_bld/$b_in
  make -j5 all-gcc
}
##-Install-##################################################
function __int_install() {
  cd $src_bld/$b_in
  make install-gcc
}
##-Post-Install-steps-#######################################
function __int_post_install() {
  cd $src_bld
}
##-Cleanup-##################################################
function __int_clean() {
  cd $src_bld
}
##-Batch-build-##############################################
function __int_batch() {
  __int_prepare
  __int_config
  __int_make
  __int_install
  __int_post_install
  __int_clean
}
#############################################################
for i; do
  __int_${i}
done
