#!/bin/sh
if [[ -r serv.sh ]]; then source serv.sh; elif [[ -r ../serv.sh ]]; then source ../serv.sh; fi
##-Global-defines-###########################################
bName="bzip2-1.0.5"
bSrc=$src_src/lib/$bName
bdir="bzip2"
b_in=$bdir/wrk
b_src=$bdir/src
##-Set-local-variables-######################################
_prx=/mingw
_hst32_="i686-w64-mingw32"
_hst64_="x86_64-w64-mingw32"
_cf="$(GetCFLAGS 32)"
_lf="$(GetLDFLAGS 32)"
_idir=${_prx}/${_hst32_}/include
_ldir=${_prx}/${_hst32_}/lib
_tag_dir=${_prx}/${_hst32_}
_tag_file=${bdir}.tag
##-Define-build-API-:)#######################################

##-Prepare-to-build-#########################################
function __int_prepare() {
  cd $src_bld
  [[ ! -d $src_bld/$b_in ]] && mkdir -p $src_bld/$b_in
  [[   -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[   -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
  mkdir -p $src_bld/$b_in
  fsLink $src_bld/$b_src $bSrc
}
##-Configure-################################################
function __int_config() {
  cd $src_bld/$b_in

  CFLAGS="${_cf}" \
  CPPFLAGS="${_cf}" \
  CXXFLAGS="${_cf}" \
  LDFLAGS="${_lf}" \
  ../src/configure \
    --prefix=${_prx} \
    --libdir=${_ldir} \
    --includedir=${_idir} \
    --infodir=${_prx}/share/info \
    --mandir=${_prx}/share/man
}
##-Make-#####################################################
function __int_make() {
  cd $src_bld/$b_in
  make all
}
##-Install-##################################################
function __int_install() {
  cd $src_bld/$b_in
  cp -f ../src/bzlib.h ${_idir}
  cp -f libbz2.a ${_ldir}
}
##-Post-Install-steps-#######################################
function __int_post_install() {
  cd $src_bld
  [[ ! -d ${_tag_dir} ]] && mkdir -p ${_tag_dir}
  local _fl=${_tag_dir}/${_tag_file}
  local v1=$(kread "VERSION" "$src_bld/$b_in/Makefile")
  echo "$bdir version $v1" >${_fl}
}
##-Cleanup-##################################################
function __int_clean() {
  cd $src_bld
  [[ -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[ -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
}
##-Batch-build-##############################################
function __int_batch() {
  __int_prepare
  __int_config
  __int_make
  __int_install
  __int_post_install
  __int_clean
}
#############################################################
for i; do
  __int_${i}
done
