#!/bin/sh
if [[ -r serv.sh ]]; then source serv.sh; elif [[ -r ../serv.sh ]]; then source ../serv.sh; fi
##-Global-defines-###########################################
bName="pthreads-2.9.0.0"
bSrc=$src_src/lib/$bName
bdir="pthreads"
b_in=$bdir/wrk
b_src=$bdir/src
##-Set-local-variables-######################################
#_prx="$(get_prefix)"
_prx=/mingw
_hst32_="i686-w64-mingw32"
_hst64_="x86_64-w64-mingw32"
_cf="$(GetCFLAGS 32)"
_lf="$(GetLDFLAGS 32)"
_idir=${_prx}/${_hst32_}/include
_ldir=${_prx}/${_hst32_}/lib
_tag_dir=${_prx}/${_hst32_}
_tag_file=${bdir}.tag
_isMingw64="1"
##-Define-build-API-:)#######################################

##-Prepare-to-build-#########################################
function __int_prepare() {
  cd $src_bld
  [[ ! -d $src_bld/$b_in ]] && mkdir -p $src_bld/$b_in
  [[   -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
  mkdir -p $src_bld/$b_in
  cp -rf $bSrc/* $src_bld/$b_in
  mv $src_bld/$b_in/config.h $src_bld/$b_in/config.h.original
  sed -e "s/#define HAVE_MINGW_W64 XXX/#define HAVE_MINGW_W64 ${_isMingw64}/" $src_bld/$b_in/config.h.original >$src_bld/$b_in/config.h
  mv $src_bld/$b_in/pthread.h $src_bld/$b_in/pthread.h.original
  sed -e "s/#define HAVE_MINGW_W64 XXX/#define HAVE_MINGW_W64 ${_isMingw64}/" $src_bld/$b_in/pthread.h.original >$src_bld/$b_in/pthread.h
}
##-Configure-################################################
function __int_config() {
  cd $src_bld/$b_in
#  [[ -r config.h.mingw32 ]] && mv -f config.h.mingw32 config.h
}
##-Make-#####################################################
function __int_make() {
  cd $src_bld/$b_in
#  make CC="$(get_cc 32)" KOPT="${_cf}" CROSS="" realclean GC-static
  make KOPT="${_cf}" CROSS="" realclean GC-static
}
##-Install-##################################################
function __int_install() {
  cd $src_bld/$b_in
  [[ ! -d ${_ldir} ]] && mkdir -p ${_ldir}
  cp -f libpthreadGC2.a ${_ldir}/
  cp -f libpthreadGC2.a ${_ldir}/libpthread.a
  [[ ! -d ${_idir} ]] && mkdir -p ${_idir}
  cp -f pthread.h sched.h semaphore.h ${_idir}/
#  cp -f pthread.h.mingw32 ${_idir}/pthread.h
}
##-Post-Install-steps-#######################################
function __int_post_install() {
  cd $src_bld
  [[ ! -d ${_tag_dir} ]] && mkdir -p ${_tag_dir}
  local _fl=${_tag_dir}/${_tag_file}
  local v1=$(extract_h_version "#define PTW32_VERSION " "$_idir/pthread.h")
  echo "$bdir version $v1 $(get_dir_ver $src_bld/$b_in)" >${_fl}
#  echo "last update $(get_dir_ver $src_bld/$b_in)" >>${_fl}

#  local v1="`grep '#define PTW32_VERSION ' ${_idir}/pthread.h | tr -s ' ' | cut -d ' ' -f 3`"
#  echo "$bdir VER: ${v1}" >>${_fl}
}
##-Cleanup-##################################################
function __int_clean() {
  cd $src_bld
  [[ -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
}
##-Batch-build-##############################################
function __int_batch() {
  __int_prepare
  __int_config
  __int_make
  __int_install
  __int_post_install
  __int_clean
}
#############################################################
for i; do
  __int_${i}
done
