#!/bin/sh
if [[ -r serv.sh ]]; then source serv.sh; elif [[ -r ../serv.sh ]]; then source ../serv.sh; fi
##-Global-defines-###########################################
bName="zlib-1.2.5"
bSrc=$src_src/lib/$bName
bdir="zlib"
b_in=$bdir/wrk
b_src=$bdir/src
##-Set-local-variables-######################################
_prx=/mingw
_hst32_="i686-w64-mingw32"
_hst64_="x86_64-w64-mingw32"
_cf="$(GetCFLAGS 64)"
_lf="$(GetLDFLAGS 64)"
_idir=${_prx}/${_hst64_}/include
_ldir=${_prx}/${_hst64_}/lib
_tag_dir=${_prx}/${_hst64_}
_tag_file=${bdir}.tag
##-Define-build-API-:)#######################################

##-Prepare-to-build-#########################################
function __int_prepare() {
  cd $src_bld
  [[ ! -d $src_bld/$b_in ]] && mkdir -p $src_bld/$b_in
  [[   -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
  mkdir -p $src_bld/$b_in
  cp -rf $bSrc/* $src_bld/$b_in
}
##-Configure-################################################
function __int_config() {
  cd $src_bld/$b_in
  cp -f contrib/amd64/amd64-match.S ./match.S
}
##-Make-#####################################################
function __int_make() {
  cd $src_bld/$b_in
  make distclean
  make -j1 CFLAGS="${_cf}" \
    LDFLAGS="${_lf}" \
    CC="${_hst64_}-gcc" \
    LD="${_hst64_}-ld" \
    RANLIB="${_hst64_}-ranlib" \
    AR="${_hst64_}-ar" \
    RC="${_hst64_}-windres" \
    LOC=-DASMV OBJA=match.o \
    -f win32/Makefile.kom lib
}
##-Install-##################################################
function __int_install() {
  cd $src_bld/$b_in
  make INCLUDE_PATH=${_idir} LIBRARY_PATH=${_ldir} -f win32/Makefile.kom install_lib
}
##-Post-Install-steps-#######################################
function __int_post_install() {
  cd $src_bld
  [[ ! -d ${_tag_dir} ]] && mkdir -p ${_tag_dir}
  local _fl=${_tag_dir}/${_tag_file}
  local v1=$(extract_h_version '#define ZLIB_VERSION "' "$_idir/zlib.h")
  echo "$bdir version $v1" >${_fl}
}
##-Cleanup-##################################################
function __int_clean() {
  cd $src_bld
  [[ -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
}
##-Batch-build-##############################################
function __int_batch() {
  __int_prepare
  __int_config
  __int_make
  __int_install
  __int_post_install
  __int_clean
}
#############################################################
for i; do
  __int_${i}
done
