#!/bin/sh
if [[ -r serv.sh ]]; then source serv.sh; elif [[ -r ../serv.sh ]]; then source ../serv.sh; fi
##-Global-defines-###########################################
_rr_="last"
#_rr_="r4044"
bName="mingw-w64.${_rr_}/mingw-w64-crt"
bSrc=$src_src/$bName
bdir="mingw-w64"
b_in=$bdir/wrk
b_src=$bdir/src
##-Set-local-variables-######################################
#_prx=/mingw_new
_prx=/mingw
_hst32_="i686-w64-mingw32"
_hst64_="x86_64-w64-mingw32"
_cf="$(GetCFLAGS 64)"
_lf="$(GetLDFLAGS 64)"
_idir="${_prx}/${_hst64_}/include"
_tag_dir="${_prx}/${_hst64_}"
_tag_file=${bdir}.tag
##-Define-build-API-:)#######################################

##-Prepare-to-build-#########################################
function __int_prepare() {
  cd $src_bld
  [[ ! -d $src_bld/$b_in ]] && mkdir -p $src_bld/$b_in
  [[   -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[   -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
  mkdir -p $src_bld/$b_in
  fsLink $src_bld/$b_src $bSrc
}
##-Configure-################################################
function __int_config() {
  cd $src_bld/$b_in

  CFLAGS="${_cf}" \
  LDFLAGS="${_lf}" \
  ../src/configure \
    --prefix=${_prx} \
    --with-sysroot=${_prx} \
    --build="${_hst32_}" \
    --host="${_hst64_}" \
    --disable-lib32 \
    --enable-lib64 \
    --disable-libce \
    --enable-warnings=2
}
##-Make-#####################################################
function __int_make() {
  cd $src_bld/$b_in
  make -j1 all
}
##-Install-##################################################
function __int_install() {
  cd $src_bld/$b_in
  make install
}
##-Post-Install-steps-#######################################
function __int_post_install() {
  cd $src_bld
  [[ ! -d ${_tag_dir} ]] && mkdir -p ${_tag_dir}
  local _fl=${_tag_dir}/${_tag_file}
  echo "$bName version $(get_dir_ver $src_bld/$b_src)" >>${_fl}
}
##-Cleanup-##################################################
function __int_clean() {
  cd $src_bld
  [[ -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[ -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
}
##-Batch-build-##############################################
function __int_batch() {
  __int_prepare
  __int_config
  __int_make
  __int_install
  __int_post_install
  __int_clean
}
#############################################################
for i; do
  __int_${i}
done
