#!/bin/sh
if [[ -r serv.sh ]]; then source serv.sh; elif [[ -r ../serv.sh ]]; then source ../serv.sh; fi
##-Global-defines-###########################################
bName="gmp-5.0.2"
#bName="gmp-4.3.2"
bSrc=$src_src/sup/$bName
bdir="gmp"
b_in=$bdir/wrk
b_src=$bdir/src
##-Set-local-variables-######################################
_prx="$(get_prefix)"
_cf="$(GetCFLAGS 32)"
_lf="$(GetLDFLAGS 32)"
_idir=${_prx}/sup/include
_ldir=${_prx}/sup/lib
_tag_dir=${_prx}/sup
_tag_file=${bdir}.tag
##-Define-build-API-:)#######################################

##-Prepare-to-build-#########################################
function __int_prepare() {
  cd $src_bld
  [[ ! -d $src_bld/$b_in ]] && mkdir -p $src_bld/$b_in
  [[   -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[   -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
  mkdir -p $src_bld/$b_in
  fsLink $src_bld/$b_src $bSrc
}
##-Configure-################################################
function __int_config() {
  cd $src_bld/$b_in

  local bld_for="pentium3-pc-mingw32"

#  CC="$(get_cc 32)" \
#  CPPFLAGS="-fexceptions" \
  ABI="32" \
  ../src/configure \
    --prefix=${_prx} \
    --build=${bld_for} \
    --libdir=${_ldir} \
    --includedir=${_idir} \
    --infodir=${_prx}/sup/info \
    --mandir=${_prx}/sup/man \
    --disable-shared \
    --enable-static \
    --enable-cxx
}
##-Make-#####################################################
function __int_make() {
  cd $src_bld/$b_in
  make -j5 all
}
##-Install-##################################################
function __int_install() {
  cd $src_bld/$b_in
  make install
  [[ -d ${_prx}/include ]] && mv -f ${_prx}/include/* ${_idir}
  [[ -d ${_prx}/include ]] && rm -rf ${_prx}/include

  local ss1="libgmp.la"
  local ss2="libgmp.la -lstdc++ -lsupc++"
  local ss0="s/$ss1/$ss2/"
  [[ -r ${_ldir}/libgmpxx.la ]] && {
    mv -f ${_ldir}/libgmpxx.la ${_ldir}/libgmpxx.la.original
    cat ${_ldir}/libgmpxx.la.original | sed -e "$ss0" >${_ldir}/libgmpxx.la
    rm -f ${_ldir}/libgmpxx.la.original
  }
  [[ -d ${_tag_dir}/info ]] && rm -rf ${_tag_dir}/info
}
##-Post-Install-steps-#######################################
function __int_post_install() {
  cd $src_bld
  [[ ! -d ${_tag_dir} ]] && mkdir -p ${_tag_dir}
  local _fl=${_tag_dir}/${_tag_file}
  local v1=$(extract_h_version "#define __GNU_MP_VERSION " "$_idir/gmp.h")
  local v2=$(extract_h_version "#define __GNU_MP_VERSION_MINOR " "$_idir/gmp.h")
  local v3=$(extract_h_version "#define __GNU_MP_VERSION_PATCHLEVEL " "$_idir/gmp.h")
  echo "$bdir version $v1.$v2.$v3" >${_fl}
}
##-Cleanup-##################################################
function __int_clean() {
  cd $src_bld
  [[ -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[ -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
}
##-Batch-build-##############################################
function __int_batch() {
  __int_prepare
  __int_config
  __int_make
  __int_install
  __int_post_install
  __int_clean
}
#############################################################
for i; do
  __int_${i}
done
