#!/bin/sh
if [[ -r serv.sh ]]; then source serv.sh; elif [[ -r ../serv.sh ]]; then source ../serv.sh; fi
##-Global-defines-###########################################
bName="mpfr-3.0.1-p4"
#bName="mpfr-3.0.0-p8"
bSrc=$src_src/sup/$bName
bdir="mpfr"
b_in=$bdir/wrk
b_src=$bdir/src
##-Set-local-variables-######################################
_prx="$(get_prefix)"
_hst32_="i686-w64-mingw32"
_hst64_="x86_64-w64-mingw32"
_cf="$(GetCFLAGS 32)"
_lf="$(GetLDFLAGS 32)"
_idir=${_prx}/sup/include
_ldir=${_prx}/sup/lib
_tag_dir=${_prx}/sup
_tag_file=${bdir}.tag
##-Define-build-API-:)#######################################

##-Prepare-to-build-#########################################
function __int_prepare() {
  cd $src_bld
  [[ ! -d $src_bld/$b_in ]] && mkdir -p $src_bld/$b_in
  [[   -d $src_bld/$b_src ]] && rm -rf $src_bld/$b_src
  [[   -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
  mkdir -p $src_bld/$b_in
  mkdir -p $src_bld/$b_src
  cp -rf $bSrc/* $src_bld/$b_src
  cd $src_bld/$b_src && autoreconf -ivf
}
##-Configure-################################################
function __int_config() {
  cd $src_bld/$b_in

#  CC="$(get_cc 32)" \
  LDFLAGS="${_lf}" \
  ../src/configure \
    --prefix=${_prx} \
    --build="${_hst32_}" \
    --with-gmp=${_prx}/sup \
    --libdir=${_ldir} \
    --includedir=${_idir} \
    --infodir=${_prx}/sup/info \
    --mandir=${_prx}/sup/man \
    --disable-shared \
    --enable-static \
    \
    --enable-thread-safe

#    --enable-decimal-float \
#    --with-gmp-build=../../gmp/src

}
##-Make-#####################################################
function __int_make() {
  cd $src_bld/$b_in
  make -j5 all
}
##-Install-##################################################
function __int_install() {
  cd $src_bld/$b_in
  make install
  [[ -d ${_prx}/share ]] && rm -rf ${_prx}/share
  [[ -d ${_tag_dir}/info ]] && rm -rf ${_tag_dir}/info
}
##-Post-Install-steps-#######################################
function __int_post_install() {
  cd $src_bld
  [[ ! -d ${_tag_dir} ]] && mkdir -p ${_tag_dir}
  local _fl=${_tag_dir}/${_tag_file}
  echo "VER: ${bdir}-`cat $src_bld/$b_src/VERSION`" >${_fl}
#  [[ -f ${_ldir}/libmpfr.la ]] && rm -f ${_ldir}/libmpfr.la
}
##-Cleanup-##################################################
function __int_clean() {
  cd $src_bld
  [[ -d $src_bld/$b_src ]] && rm -rf $src_bld/$b_src
  [[ -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
}
##-Batch-build-##############################################
function __int_batch() {
  __int_prepare
  __int_config
  __int_make
  __int_install
  __int_post_install
  __int_clean
}
#############################################################
for i; do
  __int_${i}
done
