#!/bin/sh
if [[ -r serv.sh ]]; then source serv.sh; elif [[ -r ../serv.sh ]]; then source ../serv.sh; fi
##-Global-defines-###########################################
bName="libelf-0.8.13"
bSrc=$src_src/sup/$bName
bdir="libelf"
b_in=$bdir/wrk
b_src=$bdir/src
##-Set-local-variables-######################################
_prx="$(get_prefix)"
_hst32_="i686-w64-mingw32"
_hst64_="x86_64-w64-mingw32"
_cf="$(GetCFLAGS 32)"
_lf="$(GetLDFLAGS 32)"
_idir=${_prx}/sup/include
_ldir=${_prx}/sup/lib
_tag_dir=${_prx}/sup
_tag_file=${bdir}.tag
##-Define-build-API-:)#######################################

##-Prepare-to-build-#########################################
function __int_prepare() {
  cd $src_bld
  [[ ! -d $src_bld/$b_in ]] && mkdir -p $src_bld/$b_in
  [[   -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[   -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
  mkdir -p $src_bld/$b_in
  fsLink $src_bld/$b_src $bSrc
}
##-Configure-################################################
function __int_config() {
  cd $src_bld/$b_in

#  CC="$(get_cc 32)" \
  CFLAGS="${_cf}" \
  LDFLAGS="${_lf}" \
  ../src/configure \
    --prefix=${_prx} \
    --build=${_hst32_} \
    --host=${_hst32_} \
    --libdir=${_ldir} \
    --includedir=${_idir} \
    --infodir=${_prx}/sup/info \
    --mandir=${_prx}/sup/man \
    --disable-shared \
    --disable-nls \
    --enable-static
}
##-Make-#####################################################
function __int_make() {
  cd $src_bld/$b_in
  make -j5 all
}
##-Install-##################################################
function __int_install() {
  cd $src_bld/$b_in
  make install
  [[ -d ${_ldir}/pkgconfig ]] && rm -rf ${_ldir}/pkgconfig
}
##-Post-Install-steps-#######################################
function __int_post_install() {
  cd $src_bld
  [[ ! -d ${_tag_dir} ]] && mkdir -p ${_tag_dir}
  local _fl=${_tag_dir}/${_tag_file}
  echo "$bdir version `echo ${bName} | cut -d '-' -f 2`" >${_fl}
}
##-Cleanup-##################################################
function __int_clean() {
  cd $src_bld
  [[ -d $src_bld/$b_src ]] && fsUnLink $src_bld/$b_src
  [[ -d $src_bld/$b_in ]] && rm -rf $src_bld/$b_in
  mkdir -p ${_prx}/sup/lib/1
  mv -f ${_prx}/sup/lib/*.la ${_prx}/sup/lib/1/
}
##-Batch-build-##############################################
function __int_batch() {
  __int_prepare
  __int_config
  __int_make
  __int_install
  __int_post_install
  __int_clean
}
#############################################################
for i; do
  __int_${i}
done
